/* 
 * File:   Init.h
 * Author: a
 *
 * Created on 18. Juli 2017, 17:02
 */

#ifndef INIT_H
#define	INIT_H

#define Strobe RB7
#define Data RB6
#define Clock RA7

void init (void) {
//    CCP1CON = 0b00000000; //Komparaor aus
//    CCP2CON = 0b00000000; //Komparaor aus
	TRISA = 0b00111111; //0 = output
	TRISB = 0b00111111; //1 = input
	ANSELA = 0b00011111; //RA0..4 Analogeingnge
	ANSELB = 0b00101100; //RB2..3,5 Analogeingnge,0 Encoder
    WPUB = 0b00000001; //Fr den Encoder, Pull up
	C1ON = 0; //Comparator aus 
	FVRCON = 0b00000000; //Ref. disable,Comp. off, Vref = Vdd, Vss
	OSCCON = 0b11110000; //1-PLL32MHz,1110-Int. Clock (8)oder 32 MHZ,0-unimplemented,00-Int. Clock (Config...)
	ADCON0 = 0b00000001; //AD-Channel = AN0,AD-Wandler ein
	ADCON1 = 0b00010000; //left justified,FOSC/8,GND,Vref =  Vdd,Vss 
	OPTION_REG = 0b00000001; //0-Enable pull-ups,0-INT von RB0 on falling edge,0-interne Clock,
    //0-TMR0 Incr high2low trans.,0-Prescaler assign to Timer0, nicht WDT,001-Prescaler rate 1:4
	INTCON = 0b11110000; //GIE,PEIE,TMR0IE,INTE,IOCIE,TMR0IF,INTF,IOCIF
	ADIE = 0; //AD-Interrupt en/disable
    TMR1IE = 0; //TMR1 Interrupt en/disable
	TMR2ON = 0; //TMR2 ein/ausschalten
	T2CKPS0 = 1; //Prescaler 1:4
	TMR2IE = 0; //TMR2 Interrupt en/disable
	TMR4ON = 1;	//TMR4 ein/ausschalten
	T4CKPS0	= 1; //Prescaler 1:4
	TMR4IE = 0; //TMR2 Interrupt en/disable
	TMR6ON = 0;	//TMR6 ein/ausschalten
	T6CKPS0 = 1; //Prescaler 1:4
	TMR6IE = 0; //TMR2 Interrupt en/disable
    SSP1STAT = 0b10000000; // Slew rate control enabled for
    // standard speed mode (1MHz)
    SSP1CON1 = 0b00110110; //release Clock,0110I2C Slave mode, 7-bit address
    SSP1CON2 = 0b00000001;//Clock stretching is enabled
    //AHEN und DHEN brauchts nicht, damit kann man noch mehr kontrollieren
    SSP1CON3 = 0b00000000; //ACKTIM PCIE SCIE BOEN SDAHT SBCDE AHEN DHEN
    //verschoben bertragen, weil das LSB R_nW ist
    //SSPADD aus EEPROM lesen
//    EEADRL = 0xFF;
//    CFGS = 0;
//    EEPGD = 0;
//    RD = 1;
//    SSP1ADD = EEDATL <<1;
    //SSPADD aus EEPROM lesen, Ende
    SSP1ADD = 21<<1;
    SSP1IE = 1;
    PEIE = 1; //Periphel Interrupt enable
    //Damit auf jeden Fall alle LEDs aus sind, wird die for-Schleife schon mal
    //im Init() ausgefhrt, zur Sicherheit.
    //Nicht lschen, bei STRAFE!!
    Data = 0; //Serielles Datum ist Null
    for (char i = 0; i < 8; i++) { //Acht "Bits"
        Clock = 1; //Einclocken ins Register
        Clock = 0;
    }
    Strobe = 1; //Ab ins Latch
    Strobe = 0;
}

#endif	/* INIT_H */

